/**************************************************************************//**
 * @file     main.c
 * @version  V3.00
 * $Revision: 2 $
 * $Date: 14/08/12 6:35p $
 * @brief    Demonstrate how to set GPIO pin mode and use pin data input/output control.
 * @note
 * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/
#include "stdio.h"
#include "M451Series.h"

uint32_t Volume;

/*---------------------------------------------------------------------------------------------------------*/
/*  Main Function                                                                                          */
/*---------------------------------------------------------------------------------------------------------*/
int32_t main(void)
{    
    SYS_UnlockReg();
	  /* Enable HIRC clock (Internal RC 22.1184MHz) */
    CLK_EnableXtalRC(CLK_PWRCTL_HIRCEN_Msk);
    /* Wait for HIRC clock ready */
    CLK_WaitClockReady(CLK_STATUS_HIRCSTB_Msk);
    /* Select HCLK clock source as HIRC and and HCLK clock divider as 1 */
    CLK_SetHCLK(CLK_CLKSEL0_HCLKSEL_HIRC, CLK_CLKDIV0_HCLK(1));
	  SYS_LockReg();
	
    GPIO_SetMode(PC, BIT2, GPIO_MODE_OUTPUT); //LED4
	  GPIO_SetMode(PC, BIT7, GPIO_MODE_OUTPUT); //LED7
	  
	  //ʼADC
	  CLK_EnableModuleClock(EADC_MODULE);
    SYS->GPB_MFPH &= ~(SYS_GPB_MFPH_PB9MFP_Msk | SYS_GPB_MFPH_PB10MFP_Msk);//ADCܽ
    GPIO_DISABLE_DIGITAL_PATH(PB, BIT9); //رADCͨ
	  EADC->CTL |=  EADC_CTL_ADCEN_Msk;     //ʹADC
    EADC->CTL &= (~EADC_CTL_DIFFEN_Msk);  //ADCתΪģʽ
    EADC_ConfigSampleModule(EADC, 0, EADC_SOFTWARE_TRIGGER, 6);  //ADCģ0ѡͨ6
    EADC_ENABLE_SAMPLE_MODULE_INT(EADC, 0, 0x1);//Enable sample module 0 interrupt.		
	
	  //ʼPWM
		SYS->GPC_MFPL &= ~SYS_GPC_MFPL_PC2MFP_Msk;
    SYS->GPC_MFPL |= SYS_GPC_MFPL_PC2MFP_PWM0_CH2;//PWMܽ
    /* Enable PWM module clock */
    CLK_EnableModuleClock(PWM0_MODULE);
    /* Select PWM module clock source */
    CLK_SetModuleClock(PWM0_MODULE, CLK_CLKSEL2_PWM0SEL_PCLK0, 0);//ѡPWMʱԴΪϵͳʱ
    /* Reset PWM0 channel 0~5 */
    SYS_ResetModule(PWM0_RST);		
		PWM_ConfigOutputChannel(PWM0, 2, 100, 50);   //PWM0_CH2Ƶ100Hzռձ50%
    /* Enable PWM Output path for PWM0 channel 2 */
    PWM_EnableOutput(PWM0, 0x04);
    // Start
    PWM_Start(PWM0, 0x04);
		
		while(1)
		{		  
				PC->DOUT^=BIT7;   //תIOƽ,LED˸
			  EADC_START_CONV(EADC, 0x1);    //ADʼת
				while(EADC_GET_INT_FLAG(EADC, 0x1) == 0);  //ȴת
				Volume = EADC_GET_CONV_DATA(EADC, 0);    //ȡADת
				EADC_CLR_INT_FLAG(EADC, 0x1);   //ADжϱ־
        PWM_ConfigOutputChannel(PWM0,2,100,(Volume*100/4096));//ADֵPWMռձȵLED	
        for(Volume=0;Volume<100000;Volume++);			  
		}		

}
